/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  */

import java.net.*;
import java.io.*;
import java.util.*;

public class Eqix
{
    public static void main(String[] argv)
    {        
        // String.compareTo(String)
        String line = "";
        System.out.println(" Server (s) nebo klient (c)?: ");
        DataInputStream in = new DataInputStream(System.in);

        try {line = in.readLine();}catch (IOException e) {;}
        if (line.compareTo("s") == 0)
        {
            pokec kec = new pokec();
            System.out.println(" Stiskem enteru ukoncite funkci serveru ");
            kec.start();
            try {line = in.readLine();}catch (IOException e) {;}
            kec.destroy();
        }

        if (line.compareTo("c") == 0)
        {
            System.out.println(" Zadej adresu serveru: ");
            try {line = in.readLine();}catch (IOException e) {;}
            Clnt client = new Clnt(line, 0); //127.0.0.1
            client.setKlientOut("/in");
            while(line.compareTo("/exit") != 0)
            {
                try {line = in.readLine();}catch (IOException e) {;}
                client.setKlientOut(line);
            }
            client.destruct();
        }

        System.out.println("Stiskni enter:");
        try {line = in.readLine();}catch (IOException e) {;}
    }
}

class pokec extends Thread
{
    Srvr server = new Srvr(0);
    
    public void doostatnich(String text, int i) // i - kdo to posila
    {
        int v = 0;
        for(; v < i; v++)
        {
            server.setKlientOut(text , v);
        }
        v++;
        for(; v < server.getKlientNum(); v++)
        {
            server.setKlientOut(text , v);
        }
    }
    
    public void run()
    {
            while(true)
            {
                try{sleep(200);}
                catch(InterruptedException e){;}
                if (server.getKlientNum() > 0)
                {
                    for(int i = 0; i < server.getKlientNum(); i++)
                    {
                        String comm = null;
                        comm = server.getFirstOrder(i);
                        String com0 = null, com1 = "", com2 = "", com3 = "";
                        String jmen = "";
                        char hlp = ' ';
                        if (comm != null)
                        {
                            jmen = server.getNam(i);
                            if (comm.length()>0) hlp = comm.charAt(0);
                            if (hlp == '/')
                            {
                                com0 = "";
                                if (comm.length()>1){
                                    com1 = comm.substring(0,2);
                                    com2 = comm.substring(1,comm.length());
                                }
                                if (comm.length()>5){
                                    com3 = comm.substring(0,5);                                    
                                }
                                if (comm.compareTo("/in") == 0) com0 = " Pripojil se novy uzivatel: <"+ jmen +">";
                                if (comm.compareTo("/exit") == 0) com0 = " Odpojil se klient: <"+ jmen +">";
                                if (comm.compareTo("/who") == 0)
                                {
                                    String who = "<";
                                    for(int v = 0; v < server.getKlientNum(); v++)
                                    {
                                        who += server.getNam(v) + "> <";
                                    }
                                    who = who.substring(0,who.length()-2);
                                    server.setKlientOut("Jsou napojeni: " + who , i);
                                }
                                if (com3.compareTo("/nick") == 0)
                                {
                                    com3 = comm.substring(6,comm.length());
                                    com0 = " Klient <"+ jmen +"> zmenil nick: " + com3;
                                    server.setNam(i,com3);
                                    server.setKlientOut("*Zmenil jsi nick na: " + com3 , i);
                                }
                                if (com1.compareTo("//") == 0){ comm = com2; com0 = null;}
                            }
                            if (com0 == null)
                            {
                                doostatnich("<"+ jmen +"> " + comm, i);
                            }
                            else
                            {
                                if (com0.compareTo("") != 0) doostatnich("*" + com0, i);
                            }
                        }
                    }
                }
            }
    }
    public void destroy()
    {
        server.destruct();
        this.stop();
    }
}    


/*********************************************************************
 Implementace serveru. Proud se inicializuje a spusti konstruktorem
 Srvr(port, pocet_klientu), kde port je port servru, kde se klienti
 pripoji (v pripade nastaveni portu na 0 se vygeneruje port defaultni.
 pocet_klientu je maximalni pocet zaroven pripojenych klientu. Proud
 se ukonci metodou destruct(), ktera odpoji vsechny klienty. Vystupem
 z proudu jsou metody:
    public int getKlientNum()
        - zjisti pocet napojenych klientu
    public InetAddress getKlientAdr(int nam)
        - zjisti adresu klienta jmenem nam
    public InetAddress getServerAdr()
        - zjisti adresu serveru
    public String getFirstOrder(int nam)
        - zjisti prvni neprecteny prikaz z klienta jmenem nam

Vstupem do proudu jsou tyto metody:
    public void setKonzoleON(boolean on)
        - nastavi viditelnost systemovych vystupu na konzolu
    public void setKlientOut(int nam)
        - napise text na socket klienta jmenem nam
*********************************************************************/    

class Srvr extends Thread
{
    private final static int DEPO = 6789; // defaultni port
    // informace o serveru
    private ServerSocket svsk; // socket serveru
    private InetAddress adresa; // adresa serveru
    private int port = DEPO; // port serveru
    private boolean konzoleon = true; // lock konzole
    // inicializace klientu
    private Cnct client;
    private Vector clients = new Vector(5,5);
    private int idnam = 0;

    /* konstruktor serveru*/
    public Srvr(int porty)
    {
        // Inicializace variable
        if (porty == 0) porty = DEPO; // kontrola standardniho portu
        port = porty; // konecna inicializace portu
        try
        {
            svsk = new ServerSocket(port);
            this.start(); // Spusti thread, kde hlida pripojeni klientu
        } // vytvoreni socketu serveru
        catch (IOException e) { excpa(e, "Exception pri instacovani socketu pro server.");}
    }

    /* run proudu serveru */
    public void run()
    {
        adresa = svsk.getInetAddress(); // inicializace adresy serveru
        konzole("* Server posloucha na portu: " + port); 
        konzole("* Adresa serveru: " + adresa); 
        try
        {
            while(true) // nekonecny ciklus serveru
            {
                
                    Socket klsk = svsk.accept(); // hlidej port na noveho klienta
                    client = new Cnct(klsk);
                    client.setPriority(3);
                    clients.addElement(client); // spust noveho klienta na novem portu
                    konzole("* Pocet klientu: " + clients.size());
                    client.name = "" + idnam;
                    idnam++;
            }
        }
        catch (IOException e) { excpa(e, "Exception pri naslouchani socketu");}
    }

    /* destrukce serveru */
    public void destruct()
    {
        while (svsk == null) {;} // jestli jeste neni vytvoreny v proudu tak pockej
        int pom = clients.size();
        for(int i = 0; i < pom; i++) // odpoj vsechny klienty
        {
            client = (Cnct)clients.elementAt(0);
            client.destruct(); // nejdive spust klientuv destruktor
            client = null;
        }
        try {svsk.close();}
        catch (IOException e) {excpa(e, "Vyjimka pri zavirani socketu");}
        svsk = null; // uved ukazatele do null
        adresa = null; // pro jistotu odstran i adresu serveru
        konzole("* Server je odpojen");
        this.stop(); // zastav serverovy proud
    }

    /* vypis vyjimky */
    private void excpa(Exception e, String msg)
    {
        konzole("Excpt: " + msg + ": " + e);
    }

    /* metoda pro vypis na konzoli */
    private void konzole(String msg)
    {
        if (konzoleon) System.out.println(msg);
    }

    /* z jmena klienta najde jeho aktualni cislo */
    private int getNum(String nam)
    {
        int i = 0;        
        for (i = 0; i < clients.size(); i++)
        {
           client = (Cnct)clients.elementAt(i);
           if (client.name.compareTo(nam) == 0) break;
        }
        if (client.name.compareTo(nam) == 0) return(i);
        else return(-1);
    }

    /*---------------------------------- public metody pro vstup a vystup z proudu */

    public String getNam(int num)
    {
        String s = null;
        if ((num > -1) && (num < clients.size()))
        {
            client = (Cnct)clients.elementAt(num);
            s = client.name;
        }
        return(s);
    }

    public void setNam(int num, String nick)
    {
        if ((num > -1) && (num < clients.size()))
        {
            client = (Cnct)clients.elementAt(num);
            client.name = nick;
        }
    }

    public int getKlientNum()
    {
        return(clients.size());
    }
    
    public InetAddress getKlientAdr(String nam)
    {
        int num = getNum(nam);
        if ( (num < clients.size()) && (num > -1))
        {
            client = (Cnct)clients.elementAt(num);
            return(client.getAdres());
        }
        else return(null);
    }

    public InetAddress getServerAdr()
    {
        return(adresa);
    }

    public void setKonzoleON(boolean on)
    {
        konzoleon = on;
    }
    
    public String getFirstOrder(int num)
    {
        String ven = null;
        if ((num < clients.size()) && (num > -1))
        {
            client = (Cnct)clients.elementAt(num);
            ven = client.getFirst();
        }
        return(ven);
    }

    public void setKlientOut(String outtext, int num)
    {
        if ( (num < clients.size()) && (num > -1))
        {
            client = (Cnct)clients.elementAt(num);
            client.ven(outtext);
        }
    }

    /* zde konci blok metod pro vstup a vystup z proudu------------------------------*/


    /**************************
    trida proudu pro jednotlive
    klienty.
    ***************************/
    private class Cnct extends Thread
    {
        // obevne vlastnosti klienta
        InetAddress adresak = null; // adresa klienta
        String name = "";

        // vnitrni vlastnosti klienta
        private Socket klient; // socket klienta
        private DataInputStream in; // vystup do socket
        private PrintStream out; // vstup do socketu

        // obecny zasobnik prikazu klienta
        class Order
        {
            String Comm = null; // prikaz
            public Order(String vstu)
            {
                Comm = vstu;
            }
        }
        
        Order ord;
        Vector Orders = new Vector(10,10);

        /* konstruktor proudu klienta */
        public Cnct(Socket klnt)
        {
            klient = klnt; // nastav jeho socket
            adresak = klient.getInetAddress(); // nastav jeho adresu
            try
            {
                in = new DataInputStream(klient.getInputStream()); // vytvor pro nej vstup
                out = new PrintStream(klient.getOutputStream()); // vytvor pro nej vystup
                this.start(); // spust proud klienta
            }
            catch (IOException e)
            {
                try { klient.close();} // v pripade chyby uzavri klienta
                catch (IOException e2){;}
                excpa(e, "Vyjimka pri praci s kanaly socketu");
            }
        }

        /* run proudu klienta */
        public void run()
        {
            konzole("* Pripojil se novy klient " + name + "*");
            konzole("* Adresa: " + adresak);
            String vstup = null; // pomocna promenna pro vstup ze socketu
            try
            {
                while(true) // nekonecna smycka hlida vstup ze socketu
                {
                    vstup = in.readLine(); // nacti vstup ze socketu
                    if (vstup == null) break; // hlidej ukonceni spojeni
                    konzole("* Vstup od klienta " + name + ": " + vstup);
                    Orders.addElement(new Order(vstup)); // pridej prikaz do zasobniku
                }
            }
            catch (IOException e){excpa(e, "Chyba pri naslouchani klienta: " + name);}
            finally {destruct();} // v pripade ukonceni spojeni znic klienta
        }

        /* destrukce klienta */
        public void destruct()
        {
            if (klient != null)
            {
                clients.removeElementAt(clients.indexOf(this));
                try {klient.close();} // uzavri socket
                catch (IOException e) {excpa(e, "Vyjimka pri zavirani socketu");}
                konzole("* Klient " + name + " je odpojen");
                klient = null;
                this.stop(); // zastav jeho proud
            }
        }

        /* metoda pro vystup do socketu */
        private void ven(String text)
        {
            out.println(text); // pis na socket
        }

        private InetAddress getAdres()
        {
            return(adresak);
        }
        
        private String getFirst()
        {
            if (Orders.size() > 0)
            {
                ord = (Order)Orders.elementAt(0);
                Orders.removeElementAt(0);
                return(ord.Comm);
            }
            else return(null);
        }
    }
    /************************/
}
/**********************************************************************/


/***********************************************************************
 Implementace klienta. Inicializuje se vytvorenim instance a odstrani se
 metodou destruct(). Konsturktor pozaduje adresu serveru a jeho port v
 v pripade zadani 0 se nastavi standardni. Vystupem z proudu jsou tyto
 metody:
    public InetAddress getServerAdr()
        - zjisti adresu serveru
    public int getServerPort()
        - zjisti adresu serveru
    public String getFirstCom();
        - nacte prvni neprecteny prikaz ze serveru
    
 Vstupni metody:
    public void setKlientOut(String text)
        - posle text na server
    public void setKonzoleON(boolean on)
        - vypne nebo zapne konzoli
    
***********************************************************************/
class Clnt extends Thread
{
    private final static int DEPO = 6789; // defaultni port
    private InetAddress adresa = null; // adresa serveru
    private int port = DEPO; // inicilazuj port serveru
    private Socket kliso = null; // inicializuj klientsky socket
    private DataInputStream klin;
    private PrintStream klit;
    private boolean konzoleon = true; // lock konzole

    class Order
    {
        String Comm = null; // prikaz
        public Order(String vstu)
        {
            Comm = vstu;
        }
    }
        
    Order ord;
    Vector Orders = new Vector(10,10);

    /* konstruktor klienta */
    public Clnt(String adr, int prt)
    {
        if (prt == 0) prt = DEPO; // kontrola na defaulni port
        port = prt; // uloz port
        // nejdrive vytvor socket z adresy a pak teprve uloz adresu
        try
        {
            konzole("* Klient spusten");
            kliso = new Socket(adr, port); // vytvor socket pro klienta
            klin = new DataInputStream(kliso.getInputStream()); // vytvor proud pro vstup do socketu
            klit = new PrintStream(kliso.getOutputStream()); // vytvor proud pro vystup ze socketu
            konzole("* Vytvoren socket");
            adresa = kliso.getInetAddress(); // uloz adresu serveru
            konzole("* Pripojeno na server: " + adresa + "  " + port);
            this.start();
        }
        catch (IOException e) {excpa(e, " Vyjimka pri vytvareni spojeni na server");}
    }

    /* run klienta */
    public void run()
    {
        String text = null; // pomocna promenna
        try
        {
            konzole("* Nasloucha se serveru");
            while(true) // nekonecna smycka, hlida vstup ze serveru
            {
                text = klin.readLine(); // nacti vstup ze serveru
                if (text == null)
                {
                    konzole("* Server se odpojil");
                    break;
                }
                konzole("* Vstup ze serveru: " + text);
                Orders.addElement(new Order(text)); // pridej prikaz do zasobniku
            }
        }
        catch (IOException e) {excpa(e, "Vyjimka pri cteni vstupu ze serveru");}
        finally
        {
            destruct(); // po ukonceni uzavri spojeni
        }
    }

    /* destrukce klienta */
    public void destruct()
    {
        try
        {
            if (kliso != null)
            {
                konzole("* Klient se odpojuje");
                kliso.close(); // uzavri socket
                kliso = null; // nastav ukazatel socketu na null
                konzole("* Socket je uzavren");
                this.stop(); // zastav proud klienta
            }
        }
        catch (IOException e){excpa(e, "Vyjimka pri zavirani socketu");}
    }

    /* metoda pro vypis na konzoli */
    private void konzole(String msg)
    {
        if (konzoleon) System.out.println(msg);
    }
    
    /* vypis vyjimky */
    private void excpa(Exception e, String msg)
    {
        konzole("Excpt: " + msg + ": " + e);
    }

    /* ----------------------------- blok metod pro vstup a vystup z proudu klienta */
    public InetAddress getServerAdr()
    {
        return(adresa);
    }

    public int getServerPort()
    {
        return(port);
    }

    public String getFirstCom()
    {
        ord = (Order)Orders.elementAt(0);
        Orders.removeElementAt(0);
        return(ord.Comm);
    }

    public void setKlientOut(String text)
    {
        if (text != null) klit.println(text);
    }

    public void setKonzoleON(boolean on)
    {
        konzoleon = on;
    }
    /* konec bloku pro vstup a vystup z klienta ----------------------------------- */
}
/**********************************************************************/