/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  */

import java.net.*;
import java.io.*;
import java.util.*;

public class Eqix
{
    public static void main(String[] argv)
    {
        // String.compareTo(String)
        String line = null;
        DataInputStream in = new DataInputStream(System.in);

        try {line = in.readLine();}catch (IOException e) {;}
        if (line.compareTo("s") == 0)
        {
            Srvr server = new Srvr(0, 10);
            try {line = in.readLine();}catch (IOException e) {;}
            server.setKlientOut(line, 0);
            try {line = in.readLine();}catch (IOException e) {;}
            server.destruct();
        }
        if (line.compareTo("c") == 0)
        {
            Clnt client = new Clnt("", 0); //127.0.0.1
            while(line.compareTo("d") != 0)
            {
                try {line = in.readLine();}catch (IOException e) {;}
                client.setKlientOut(line);
            }
            client.destruct();
        }

        System.out.println("Stiskni enter:");
        try {line = in.readLine();}catch (IOException e) {;}
    }
}


/*********************************************************************
 Implementace serveru. Proud se inicializuje a spusti konstruktorem
 Srvr(port, pocet_klientu), kde port je port servru, kde se klienti
 pripoji (v pripade nastaveni portu na 0 se vygeneruje port defaultni.
 pocet_klientu je maximalni pocet zaroven pripojenych klientu. Proud
 se ukonci metodou destruct(), ktera odpoji vsechny klienty. Vystupem
 z proudu jsou metody:
    public int getKlientNum()
        - zjisti pocet napojenych klientu
    public InetAddress getKlientAdr(int num)
        - zjisti adresu klienta cislo num
    public InetAddress getServerAdr()
        - zjisti adresu serveru
    public String getFirstOrder(int num)
        - zjisti prvni neprecteny prikaz z klienta cilso num

Vstupem do proudu jsou tyto metody:
    public void setKonzoleON(boolean on)
        - nastavi viditelnost systemovych vystupu na konzolu
    public void setKlientOut(int num)
        - napise text na socket klienta cislo num
*********************************************************************/

class Srvr extends Thread
{
    private final static int DEPO = 6789; // defaultni port
    private int NOCL; // max pocet klientu
    // informace o serveru
    private ServerSocket svsk; // socket serveru
    private InetAddress adresa; // adresa serveru
    private int port = DEPO; // port serveru
    private boolean konzoleon = true; // lock konzole
    // informace o vsech klientech
    private int pocet_klientu = 0; // pocet pripojenych klientu
    // inicializace klientu
    private Cnct[] client;

    /* konstruktor serveru*/
    public Srvr(int porty, int n)
    {
        // Inicializace variable
        NOCL = n; // maximalni pocet klientu
        client = new Cnct[NOCL]; // inicializace klientu
        for(int i = 0; i < NOCL; i++)
        {
            client[i] = new Cnct(); // vyvolani konstruktoru vsech klientu
        }
        if (porty == 0) porty = DEPO; // kontrola standardniho portu
        port = porty; // konecna inicializace portu
        try { svsk = new ServerSocket(port); } // vytvoreni socketu serveru
        catch (IOException e) { excpa(e, "Exception pri instacovani socketu pro server.");}
        this.start(); // Spusti thread, kde hlida pripojeni klientu
    }

    /* run proudu serveru */
    public void run()
    {
        adresa = svsk.getInetAddress(); // inicializace adresy serveru
        konzole("* Server posloucha na portu: " + port);
        konzole("* Adresa serveru: " + adresa);
        int number = 0; // pomocna promenna
        try
        {
            while(true) // nekonecny ciklus serveru
            {
                number = getfreepos(); // zjisti volnou pozici pro noveho klienta
                if (number == -1) bezect(); // kdyz zadna neni spust pomocnou metodu
                else
                {
                    Socket klsk = svsk.accept(); // hlidej port na noveho klienta
                    client[number].make(klsk, number); // spust noveho klienta na novem portu
                    pocet_klientu++; // zvys aktualni pocet klientu
                    konzole("* Pocet klientu: " + pocet_klientu);
                }
            }
        }
        catch (IOException e) { excpa(e, "Exception pri naslouchani socketu");}
    }

    /* destrukce serveru */
    public void destruct()
    {
        this.stop(); // zastav serverovy proud
        while (svsk == null) {;} // jestli jeste neni vytvoreny v proudu tak pockej
        for(int i = 0; i < NOCL; i++) // odpoj vsechny klienty
        {
            client[i].destruct(); // nejdive spust klientuv destruktor
            client[i] = null; // potom odstran ukazatel pockej az je odstrani garbage
        }
        try {svsk.close();}
        catch (IOException e) {excpa(e, "Vyjimka pri zavirani socketu");}
        svsk = null; // uved ukazatele do null
        adresa = null; // pro jistotu odstran i adresu serveru
        pocet_klientu = 0; // nastav pocet klientu na 0
        konzole("* Server je odpojen");
    }

    /* vypis vyjimky */
    private void excpa(Exception e, String msg)
    {
        konzole("Excpt: " + msg + ": " + e);
    }

    /* zjisteni volne pozice pro noveho klienta */
    private int getfreepos()
    {
        int i = 0; // pomocna prommena

        while((client[i].free == false)&&(i < NOCL)) { i++;} // prohledej vsechy klienty a prvniho nepouzivaneho vyber

        if (i == (NOCL - 1)) i = -1; // pokud neni ani jedna pozice volna vyhod -1
        return(i);
    }

    /* pomocna metoda pro neexistujici volne misto pro noveho klientu */
    private void bezect()
    {
        konzole("* Pripojil se maximalni pocet uzivatelu");
    }

    /* metoda pro vypis na konzoli */
    private void konzole(String msg)
    {
        if (konzoleon) System.out.println(msg);
    }

    /* metoda zjistuje volne misto pro zapis do zasobniku prikazu klienta */
    private int getFreeComm(int num)
    {
        if (num < NOCL) // ujisti se ze se nezapisuje mimo pole
        {
            int i=0; // pomocna promenna
            while((client[num].Order[i].Comm != null)&&(i < 32)) {i++;} // najdi volne misto
            if (client[num].Order[i].Comm != null) return(-1); // v pripade ze zadne neni vrat -1
            else return(i); // jinak jeho cislo
        }
        else return(-2); // v pripade ze se zapisuje mimo pole vrat -2
    }

    /* metoda pro pridani prikazu do zasobniku */
    private void addOrder(int num, String comm)
    {
        if (num < NOCL) // ujisti se ze se nezapisuje mimo pole
        {
            int free = getFreeComm(num); // pomocnou promennou napln cislem volneho pole
            if (free > -1) // v pripade ze je volne pole
            {
                client[num].Order[free].Comm = comm; // zapis prikaz do volneho pole
                client[num].Order[free].Num = client[num].last_order; // zapis jeho poradove cislo
                client[num].last_order++; // zvys posledni mozne pouzitelne poradove cislo
            }
            else konzole("Err: Dosly polozky v Order klienta:" + client[num].cislo); // jinak oznam chybu
        }
    }

    /*---------------------------------- public metody pro vstup a vystup z proudu */
    public int getKlientNum()
    {
        return(pocet_klientu);
    }

    public InetAddress getKlientAdr(int num)
    {
        if ((num < NOCL)&&(client[num].free == false)) return(client[num].adresak);
        else return(null);
    }

    public InetAddress getServerAdr()
    {
        return(adresa);
    }

    public void setKonzoleON(boolean on)
    {
        konzoleon = on;
    }

    public String getFirstOrder(int num)
    {
        String ven = null;
        if ((num < NOCL)&&(client[num].free == false))
        {
            int i = 0;
            while((client[num].Order[i].Num != 0)&&(i < 32)) {i++;}
            if (client[num].Order[i].Num != 0) konzole("Err: Chyba v nastaveni Order klienta:" + client[num].cislo);
            else
            {
                ven = client[num].Order[i].Comm;
                client[num].Order[i].Comm = null;
                for(i = 0; i < 32; i++)
                {
                    client[num].Order[i].Num--;
                    client[num].last_order--;
                }
            }
        }
        return(ven);
    }

    public void setKlientOut(String outtext, int num)
    {
        if (outtext != null) if ((num < NOCL)&&(client[num].free == false)) client[num].ven(outtext);
    }
    /* zde konci blok metod pro vstup a vystup z proudu------------------------------*/


    /**************************
    trida proudu pro jednotlive
    klienty.
    ***************************/
    private class Cnct extends Thread
    {
        // obevne vlastnosti klienta
        boolean free = true; // lock volne misto pro noveho klienta
        int cislo = 0; // cislo klienta
        InetAddress adresak = null; // adresa klienta

        // vnitrni vlastnosti klienta
        private Socket klient; // socket klienta
        private DataInputStream in; // vystup do socket
        private PrintStream out; // vstup do socketu

        // obecny zasobnik prikazu klienta
        private int last_order = 0; // posledni pouzitelne cislo prikazu
        class zasobnik // zasobnik prikazu klienta
        {
            String Comm = null; // prikaz
            int Num = 0; // poradove cislo prikazu
        }

        zasobnik[] Order = new zasobnik[32]; // vytvor zasobnik o 32 polozkach

        /* konstruktor proudu klienta */
        public Cnct()
        {
            free = true; // jen se inicializuje jako prazdne
            klient = null; // a socket nastavi na null
        }

        /* run proudu klienta */
        public void run()
        {
            String vstup = null; // pomocna promenna pro vstup ze socketu
            try
            {
                while(true) // nekonecna smycka hlida vstup ze socketu
                {
                    vstup = in.readLine(); // nacti vstup ze socketu
                    if (vstup == null) break; // hlidej ukonceni spojeni
                    konzole("* Vstup od klienta " + cislo + ": " + vstup);
//                    addOrder(cislo, vstup); // pridej prikaz do zasobniku
                }
            }
            catch (IOException e){excpa(e, "Chyba pri naslouchani klienta: " + cislo);}
            finally {destruct();} // v pripade ukonceni spojeni znic klienta
        }

        /* destrukce klienta */
        public void destruct()
        {
            if (free == false) // jen v pripade je-li plny (pro prvni inicializaci)
            {
                try {klient.close();} // uzavri socket
                catch (IOException e) {excpa(e, "Vyjimka pri zavirani socketu");}
                konzole("* Klient " + cislo + " je odpojen");
                pocet_klientu --; // sniz pocet klientu
                free = true; // oznac ho jako volneho
                this.stop(); // zastav jeho proud
            }
        }

        /* metoda pro spusteni klienta */
        private void make(Socket klnt, int num)
        {
            free = false; // oznac klienta jako plneho
            klient = klnt; // nastav jeho socket
            adresak = klient.getInetAddress(); // nastav jeho adresu
            cislo = num;
            try
            {
                in = new DataInputStream(klient.getInputStream()); // vytvor pro nej vstup
                out = new PrintStream(klient.getOutputStream()); // vytvor pro nej vystup
            }
            catch (IOException e)
            {
                try { klient.close();} // v pripade chyby uzavri klienta
                catch (IOException e2){;}
                excpa(e, "Vyjimka pri praci s kanaly socketu");
            }
            konzole("* Pripojil se novy klient " + cislo);
            konzole("* Adresa: " + adresak);
            this.start(); // spust proud klienta
        }

        /* metoda pro vystup do socketu */
        private void ven(String text)
        {
            out.println(text); // pis na socket
        }
    }
    /************************/
}
/**********************************************************************/


/***********************************************************************
 Implementace klienta. Inicializuje se vytvorenim instance a odstrani se
 metodou destruct(). Konsturktor pozaduje adresu serveru a jeho port v
 v pripade zadani 0 se nastavi standardni. Vystupem z proudu jsou tyto
 metody:
    public InetAddress getServerAdr()
        - zjisti adresu serveru
    public int getServerPort()
        - zjisti adresu serveru
    public String getFirstCom();
        - nacte prvni neprecteny prikaz ze serveru

 Vstupni metody:
    public void setKlientOut(String text)
        - posle text na server
    public void setKonzoleON(boolean on)
        - vypne nebo zapne konzoli

***********************************************************************/
class Clnt extends Thread
{
    private final static int DEPO = 6789; // defaultni port
    private InetAddress adresa = null; // adresa serveru
    private int port = DEPO; // inicilazuj port serveru
    private Socket kliso = null; // inicializuj klientsky socket
    private DataInputStream klin;
    private PrintStream klit;
    private boolean konzoleon = true; // lock konzole

    class zasobnik // zasobnik prikazu ze serveru
    {
        String Comm = null; // prikaz
        int Num = 0; // poradove cislo prikazu
    }
    private int last_order = 0;

    zasobnik[] Order = new zasobnik[32]; // vytvor zasobnik o 32 polozkach

    /* konstruktor klienta */
    public Clnt(String adr, int prt)
    {
        if (prt == 0) prt = DEPO; // kontrola na defaulni port
        port = prt; // uloz port
        // nejdrive vytvor socket z adresy a pak teprve uloz adresu
        try
        {
            konzole("* Klient spusten");
            kliso = new Socket(adr, port); // vytvor socket pro klienta
            klin = new DataInputStream(kliso.getInputStream()); // vytvor proud pro vstup do socketu
            klit = new PrintStream(kliso.getOutputStream()); // vytvor proud pro vystup ze socketu
            konzole("* Vytvoren socket");
            adresa = kliso.getInetAddress(); // uloz adresu serveru
            konzole("* Pripojeno na server: " + adresa + "  " + port);
            this.start();
        }
        catch (IOException e) {excpa(e, " Vyjimka pri vytvareni spojeni na server");}
    }

    /* run klienta */
    public void run()
    {
        String text = null; // pomocna promenna
        try
        {
            while(true) // nekonecna smycka, hlida vstup ze serveru
            {
                konzole("* Nasloucha se serveru");
                text = klin.readLine(); // nacti vstup ze serveru
                if (text == null)
                {
                    konzole("* Server se odpojil");
                    break;
                }
                konzole("* Vstup ze serveru: " + text);
//                addOrder(text); // uloz text do zasobniku
            }
        }
        catch (IOException e) {excpa(e, "Vyjimka pri cteni vstupu ze serveru");}
        finally
        {
            destruct(); // po ukonceni uzavri spojeni
        }
    }

    /* destrukce klienta */
    public void destruct()
    {
        try
        {
            if (kliso != null)
            {
                konzole("* Klient se odpojuje");
                kliso.close(); // uzavri socket
                kliso = null; // nastav ukazatel socketu na null
                konzole("* Socket je uzavren");
                this.stop(); // zastav proud klienta
            }
        }
        catch (IOException e){excpa(e, "Vyjimka pri zavirani socketu");}
    }

    /* metoda pro vypis na konzoli */
    private void konzole(String msg)
    {
        if (konzoleon) System.out.println(msg);
    }

    /* vypis vyjimky */
    private void excpa(Exception e, String msg)
    {
        konzole("Excpt: " + msg + ": " + e);
    }

    /* metoda zjistuje volne misto pro zapis do zasobniku prikazu klienta */
    private int getFreeComm()
    {
        int i=0; // pomocna promenna
        while((Order[i].Comm != null)&&(i < 32)) {i++;} // najdi volne misto
        if (Order[i].Comm != null) return(-1); // v pripade ze zadne neni vrat -1
        else return(i); // jinak jeho cislo
    }

    /* prida prikaz do zasobniku */
    private void addOrder(String comm)
    {
        int free = getFreeComm(); // pomocnou promennou napln cislem volneho pole
        if (free > -1) // v pripade ze je volne pole
        {
            Order[free].Comm = comm; // zapis prikaz do volneho pole
            Order[free].Num = last_order; // zapis jeho poradove cislo
            last_order++; // zvys posledni mozne pouzitelne poradove cislo
        }
        else konzole("Err: Dosly polozky v Order klienta"); // jinak oznam chybu
    }

    /* ----------------------------- blok metod pro vstup a vystup z proudu klienta */
    public InetAddress getServerAdr()
    {
        return(adresa);
    }

    public int getServerPort()
    {
        return(port);
    }

    public String getFirstCom()
    {
        String ven = null;
        int i = 0;
        while((Order[i].Num != 0)&&(i < 32)) {i++;}
        if (Order[i].Num != 0) konzole("Err: Chyba v nastaveni Order klienta");
        else
        {
            ven = Order[i].Comm;
            Order[i].Comm = null;
            for(i = 0; i < 32; i++)
            {
                Order[i].Num--;
                last_order--;
            }
        }
        return(ven);
    }

    public void setKlientOut(String text)
    {
/*???*/  if (text != null) klit.println(text);
    }

    public void setKonzoleON(boolean on)
    {
        konzoleon = on;
    }
    /* konec bloku pro vstup a vystup z klienta ----------------------------------- */
}
/**********************************************************************/